<?php
/**
 *
 * @mod Friend Request Approval Mod
 * @author Blue Blood (Blue Blood) blueblood@projectblueblood.com
 * @version 0.8.0
 * @copyright (c) 2010 Blue Blood
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */
define('UMIL_AUTO', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
define('IN_PHPBB', true);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup(); 
if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}
$mod_name = 'Friend Request Approval MOD';
$version_config_name = 'fram_version';
$language_file = 'mods/info_ucp_fram';
//$logo_img = 'styles/prosilver/imageset/site_logo.gif';
$versions = array(
	'0.8.0' => array(
		'module_add' => array(
				array('acp', 'ACP_CAT_DOT_MODS', 'FRAM_ACP_CAT'),
				array('ucp', 'UCP_ZEBRA', 'FRAM_UCP_BLOCK'),
				array('ucp', 'UCP_ZEBRA', 'FRAM_UCP_REQUESTS'),
				array('ucp', 'UCP_ZEBRA', 'FRAM_UCP_SETTINGS'),
				
			array('acp', 'FRAM_ACP_CAT', array(
					'module_basename'	=> 'fram',
					'modes'   			=> array('index'),
					),
				),
			array('ucp', 'FRAM_UCP_BLOCK', array(
					'module_basename'	=> 'fram',
					'modes'   			=> array('block_list'),
				),
			),
			array('ucp', 'FRAM_UCP_REQUESTS', array(
					'module_basename'	=> 'fram',
					'modes'   			=> array('view_requests'),
				),
			),
			array('ucp', 'FRAM_UCP_SETTINGS', array(
					'module_basename'	=> 'fram',
					'modes'   			=> array('settings'),
				),
			),
		),

        'table_column_add' => array(
			array('phpbb_zebra', 'req_friends', array('TINT:1', 0)),
			array('phpbb_zebra', 'block', array('TINT:1', 0)),
            array('phpbb_users', 'user_allow_frama', array('TINT:1', 1)),
            array('phpbb_users', 'user_allow_framd', array('TINT:1', 1)),
            array('phpbb_users', 'user_allow_framb', array('TINT:1', 1)),
            array('phpbb_users', 'requests', array('UINT', 0)),
        	),
		
		'config_add' => array(
			array('fram_enable', 0, 0),
			array('fram_approve', 0, 0),
			array('fram_deny', 0, 0),
			array('fram_block', 0, 0),
			),
		
		'cache_purge' => '',
	),
);
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);
?>