<?php
/**
 *
 * @mod Friend Request Approval Mod
 * @author Blue Blood (Blue Blood) blueblood@projectblueblood.com
 * @version 0.8.0
 * @copyright (c) 2010 Blue Blood
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */
if (!defined('IN_PHPBB'))
{
	exit;
}
/**
* ucp_fram
* @package ucp
*/
class ucp_fram
{
	var $u_action;
	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template, $phpbb_root_path, $phpEx;
		include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
		$submit	= (isset($_POST['submit'])) ? true : false;
		$s_hidden_fields = '';
		$error = $data = array();
		$type = request_var('type', '');
		$zebra_id = request_var('uid', 0);
		$pm_blocking = (isset($config['enable_foe_pm_blocking'])) ? $config['enable_foe_pm_blocking'] : 0;
		$user->add_lang('mods/fram_lang');
		switch ($mode)
		{
			case 'block_list':
				$template->assign_var('S_BLOCK_LIST', true);
				if ($type)
				{
					$sql = 'DELETE FROM ' . ZEBRA_TABLE . '
						WHERE user_id = ' . $zebra_id . '
							AND zebra_id = ' . $user->data['user_id'];
					$db->sql_query($sql);

					$sql = 'SELECT * FROM ' . ZEBRA_TABLE . '
						WHERE user_id = ' . $user->data['user_id'] . '
							AND zebra_id = ' . $zebra_id;
					$result = $db->sql_query($sql);

					if ($row = $db->sql_fetchrow($result))
					{
						$sql = 'DELETE FROM ' . ZEBRA_TABLE . '
							WHERE user_id = ' . $user->data['user_id'] . '
								AND zebra_id = ' . $zebra_id;
						$db->sql_query($sql);
					}
					$db->sql_freeresult($result);
					if ($pm_blocking)
					{
						$sql = 'DELETE FROM ' . ZEBRA_PM_TABLE . '
							WHERE user_id = ' . $zebra_id . '
								AND zebra_pm_id = ' . $user->data['user_id'];
						$db->sql_query($sql);
					}
					meta_refresh(3, $this->u_action);
					trigger_error($user->lang['FRAM_USER_UNBLOCKED']);
				}
				else
				{
					$sql = 'SELECT * FROM ' . ZEBRA_TABLE . '
						WHERE zebra_id = ' . $user->data['user_id'] . '
							AND block = 1';
					$result = $db->sql_query($sql);
					while ($users = $db->sql_fetchrow($result))
					{
						$sql = 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $users['user_id'];
						$results = $db->sql_query($sql);
						$row = $db->sql_fetchrow($results);
						$db->sql_freeresult($results);
						$avatar_hw_max = '40';
						$avatar_width = $row['user_avatar_width'] ? (($row['user_avatar_width'] > $row['user_avatar_height']) ? $avatar_hw_max : ($avatar_hw_max / $row['user_avatar_height']) * $row['user_avatar_width']) : $avatar_hw_max;
						$avatar_height = $row['user_avatar_height'] ? (($row['user_avatar_height'] > $row['user_avatar_width']) ? $avatar_hw_max : ($avatar_hw_max / $row['user_avatar_width']) * $row['user_avatar_height']) : $avatar_hw_max;
						$template->assign_block_vars('list', array(
							'USER_ID'			=> $users['user_id'],
							'USERNAME'			=> get_username_string('full', $users['user_id'], $row['username'], $row['user_colour']),
							'AVATAR'			=> $row['user_avatar'] ? get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $avatar_width, $avatar_height) : '<img src="'.$phpbb_root_path.'styles/'.$user->theme['theme_path'].'/theme/images/no_avatar.gif" width="' . $avatar_width . '" title="' . $row['username'] . '" alt="' . $row['username'] . '" height="' . $avatar_height . '" />',
							'U_USERNAME'		=> get_username_string('profile', $users['user_id'], $row['username'], $row['user_colour']),
							'U_UNBLOCK'			=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=fram&amp;mode=block_list&amp;type=unblock&amp;uid=' . $users['user_id'] . ''),
						));
					}
					$db->sql_freeresult($result);
				}
			break;
			case 'view_requests':
				$template->assign_var('S_REQUEST', true);
				if ($type)
				{
					switch ($type)
					{
						case 'approve':
							$sql = 'UPDATE ' . ZEBRA_TABLE . '
								SET friend = 1, foe = 0, req_friends = 0
									WHERE user_id = ' . $zebra_id . '
										AND zebra_id = ' . $user->data['user_id'];
							$db->sql_query($sql);
							$sql = 'SELECT * FROM ' . ZEBRA_TABLE . '
								WHERE user_id = ' . $user->data['user_id'] . '
									AND zebra_id = ' . $zebra_id;
							$result = $db->sql_query($sql);
							if (!($row = $db->sql_fetchrow($result)))
							{
								$sql = 'INSERT INTO ' . ZEBRA_TABLE . " (user_id, zebra_id, friend, foe, req_friends) VALUES (" . $user->data['user_id'] . ", " . $zebra_id . ', 1, 0, 0)';
								$db->sql_query($sql);
							}
							else
							{
								$sql = 'UPDATE ' . ZEBRA_TABLE . ' SET friend = 1, foe = 0, req_friends = 0
									WHERE user_id = ' . $user->data['user_id'] . '
										AND zebra_id = ' . $zebra_id;
								$db->sql_query($sql);
							}
							$sql = 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $user->data['user_id'];
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$db->sql_freeresult($result);
							$requests = ($row['requests'] <= 0) ? 0 : $row['requests'] - 1;
							$sql = 'UPDATE ' . USERS_TABLE . ' SET requests = ' . $requests . ' WHERE user_id = ' . $user->data['user_id'];
							$db->sql_query($sql);
							if ($config['fram_approve'] != 1)
							if ($user->data['user_allow_frama'])
							{
							$this->send_pm('approve', $zebra_id, $user->data['user_id']);
							}
							if ($config['fram_approve'])
							{
							$this->send_pm('approve', $zebra_id, $user->data['user_id']);
							}
							meta_refresh(3, $this->u_action);
							trigger_error($user->lang['FRAM_REQUEST_APPROVED']);
						break;
						case 'deny':
							$sql = 'DELETE FROM ' . ZEBRA_TABLE . '
								WHERE user_id = ' . $zebra_id . '
									AND zebra_id = ' . $user->data['user_id'];
							$db->sql_query($sql);
							$sql = 'SELECT * FROM ' . ZEBRA_TABLE . '
								WHERE user_id = ' . $user->data['user_id'] . '
									AND zebra_id = ' . $zebra_id;
							$result = $db->sql_query($sql);
							if ($row = $db->sql_fetchrow($result))
							{
								$sql = 'DELETE FROM ' . ZEBRA_TABLE . '
									WHERE user_id = ' . $user->data['user_id'] . '
										AND zebra_id = ' . $zebra_id;
								$db->sql_query($sql);
							}
							$sql = 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $user->data['user_id'];
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$db->sql_freeresult($result);
							$requests = ($row['requests'] <= 0) ? 0 : $row['requests'] - 1;
							$sql = 'UPDATE ' . USERS_TABLE . ' SET requests = ' . $requests . ' WHERE user_id = ' . $user->data['user_id'];
							$db->sql_query($sql);
							if ($config['fram_deny'] != 1)
							if ($user->data['user_allow_framd'])
							{
							$this->send_pm('deny', $zebra_id, $user->data['user_id']);
							}
							if ($config['fram_deny'])
							{
							$this->send_pm('deny', $zebra_id, $user->data['user_id']);
							}
							meta_refresh(3, $this->u_action);
							trigger_error($user->lang['FRAM_REQUEST_DENIED']);
						break;
						case 'block':
							$sql = 'UPDATE ' . ZEBRA_TABLE . '
								SET block = 1, req_friends = 0
									WHERE user_id = ' . $zebra_id . '
										AND zebra_id = ' . $user->data['user_id'];
							$db->sql_query($sql);
							if ($pm_blocking)
							{
								$sql_ary[] = array(
									'user_id'			=> (int) $zebra_id,
									'zebra_pm_id'		=> (int) $user->data['user_id'],
									'zebra_pm_reason'	=> (string) '',
									'foe'				=> 1,
								);

								$db->sql_multi_insert(ZEBRA_PM_TABLE, $sql_ary);
							}
							$sql = 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $user->data['user_id'];
							$result = $db->sql_query($sql);
							$row = $db->sql_fetchrow($result);
							$db->sql_freeresult($result);
							$requests = ($row['requests'] <= 0) ? 0 : $row['requests'] - 1;
							$sql = 'UPDATE ' . USERS_TABLE . ' SET requests = ' . $requests . ' WHERE user_id = ' . $user->data['user_id'];
							$db->sql_query($sql);
							if ($config['fram_block'] != 1)
							if ($user->data['user_allow_framb'])
							{
							$this->send_pm('block', $zebra_id, $user->data['user_id']);
							}
							if ($config['fram_block'])
							{
							$this->send_pm('block', $zebra_id, $user->data['user_id']);
							}
							meta_refresh(3, $this->u_action);
							trigger_error($user->lang['FRAM_REQUEST_BLOCKED']);
						break;
					}
				}
				else
				{
					$sql = 'SELECT * FROM ' . ZEBRA_TABLE . '
						WHERE zebra_id = ' . (int) $user->data['user_id'] . '
							AND friend = 0
							AND foe = 0
							AND block = 0
							AND req_friends = 1';
					$result = $db->sql_query($sql);
					while ($users = $db->sql_fetchrow($result))
					{
						$sql = 'SELECT * FROM ' . USERS_TABLE . ' WHERE user_id = ' . $users['user_id'];
						$results = $db->sql_query($sql);
						$row = $db->sql_fetchrow($results);
						$db->sql_freeresult($results);
						$avatar_hw_max = '40';
						$avatar_width = $row['user_avatar_width'] ? (($row['user_avatar_width'] > $row['user_avatar_height']) ? $avatar_hw_max : ($avatar_hw_max / $row['user_avatar_height']) * $row['user_avatar_width']) : $avatar_hw_max;
						$avatar_height = $row['user_avatar_height'] ? (($row['user_avatar_height'] > $row['user_avatar_width']) ? $avatar_hw_max : ($avatar_hw_max / $row['user_avatar_width']) * $row['user_avatar_height']) : $avatar_hw_max;
						$template->assign_block_vars('list', array(
							'USER_ID'			=> $users['user_id'],
							'USERNAME'			=> get_username_string('full', $users['user_id'], $row['username'], $row['user_colour']),
							'AVATAR'			=> $row['user_avatar'] ? get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $avatar_width, $avatar_height) : get_user_avatar($phpbb_root_path.'styles/'.$user->theme['theme_path'].'/theme/images/no_avatar.gif', 2, $avatar_width, $avatar_height),
							'MESSAGE'			=> $users['message'],
							'U_USERNAME'		=> get_username_string('profile', $users['user_id'], $row['username'], $row['user_colour']),
							'U_APPROVE'			=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=fram&amp;mode=view_requests&amp;type=approve&amp;uid=' . $users['user_id'] . ''),
							'U_DENY'			=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=fram&amp;mode=view_requests&amp;type=deny&amp;uid=' . $users['user_id'] . ''),
							'U_BLOCK'			=> append_sid("{$phpbb_root_path}ucp.$phpEx", 'i=fram&amp;mode=view_requests&amp;type=block&amp;uid=' . $users['user_id'] . ''),
						));
					}
					$db->sql_freeresult($result);
				}
			break;
			case 'settings':			
				$template->assign_var('S_SETTINGS', true);
				add_form_key('ucp_fram');
				$data = array(
					'frama'		=> request_var('frama', (bool) $user->data['user_allow_frama']),
					'framd'		=> request_var('framd', (bool) $user->data['user_allow_framd']),
					'framb'		=> request_var('framb', (bool) $user->data['user_allow_framb']),
					);
				if ($submit)
				{
				$sql_ary = array(
					'user_allow_frama'	=> $data['frama'],
					'user_allow_framd'	=> $data['framd'],
					'user_allow_framb'	=> $data['framb'],
					);
						$sql = 'UPDATE ' . USERS_TABLE . '
							SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
							WHERE user_id = ' . $user->data['user_id'];
						$db->sql_query($sql);
						meta_refresh(3, $this->u_action);
						$message = $user->lang['PREFERENCES_UPDATED'] . '<br /><br />' . sprintf($user->lang['RETURN_UCP'], '<a href="' . $this->u_action . '">', '</a>');
						trigger_error($message);
					}
				$template->assign_vars(array(
					'S_FRAMA'		=> $data['frama'],
					'S_FRAMD'		=> $data['framd'],
					'S_FRAMB'		=> $data['framb'],
					));
			break;
			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}
		$template->assign_vars(array(
			'L_TITLE'			=> $user->lang['FRAM_REQUESTS'],
		));
		$this->tpl_name = 'ucp_fram';
		$this->page_title = 'FRAM_REQUESTS';
	}
	function send_pm($status, $user_id, $zebra_id)
	{
		global $auth, $db, $user, $phpbb_root_path, $phpEx;
		include($phpbb_root_path . 'includes/functions_privmsgs.' . $phpEx);
		include($phpbb_root_path . 'includes/message_parser.' . $phpEx);
		$message_parser = new parse_message();
		$sql = 'SELECT user_id, username, user_email, user_lang, user_jabber, user_notify_type
			FROM ' . USERS_TABLE . '
			WHERE user_id = ' . $user_id;
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			$contact_users[] = $row;
		}
		$db->sql_freeresult($result);
		$sql = 'SELECT * FROM ' . USERS_TABLE . '
			WHERE user_id = ' . $zebra_id;
		$result = $db->sql_query($sql);
		while ($row = $db->sql_fetchrow($result))
		{
			$sender = $row;
		}
		$db->sql_freeresult($result);
		switch ($status)
		{
			case 'approve':
				$subject = $user->lang['FRAM_APPROVED_SUBJECT'];
				$message_parser->message = sprintf($user->lang['FRAM_APPROVED_MESSAGE'], $sender['username']);
			break;
		}
		switch ($status)
		{
			case 'deny':
				$subject = $user->lang['FRAM_DENIED_SUBJECT'];
				$message_parser->message = sprintf($user->lang['FRAM_DENIED_MESSAGE'], $sender['username']);
			break;
		}
		switch ($status)
		{
			case 'block':
				$subject = $user->lang['FRAM_BLOCK_SUBJECT'];
				$message_parser->message = sprintf($user->lang['FRAM_BLOCK_MESSAGE'], $sender['username']);
			break;
		}
		$subject = utf8_normalize_nfc($subject);
		$message_parser->message = utf8_normalize_nfc($message_parser->message);
		$message_parser->parse(true, true, true);
		$pm_data = array(
			'from_user_id'		=> $sender['user_id'],
			'from_user_ip'		=> $sender['user_ip'],
			'from_username'		=> $sender['username'],
			'enable_sig'		=> false,
			'enable_bbcode'		=> true,
			'enable_smilies'	=> true,
			'enable_urls'		=> false,
			'icon_id'			=> 0,
			'bbcode_bitfield'	=> $message_parser->bbcode_bitfield,
			'bbcode_uid'		=> $message_parser->bbcode_uid,
			'message'			=> $message_parser->message,
		);
		for ($i = 0, $size = sizeof($contact_users); $i < $size; $i++)
		{
			$pm_data['address_list'] = array('u' => array($contact_users[$i]['user_id'] => 'to'));
			submit_pm('post', $subject, $pm_data, true);
		}
	}
}
?>