<?php
/**
 *
 * @mod Friend Request Approval Mod
 * @author Blue Blood (Blue Blood) blueblood@projectblueblood.com
 * @version 0.8.0
 * @copyright (c) 2010 Blue Blood
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */
if (!defined('IN_PHPBB'))
{
	exit;
}
if (empty($lang) || !is_array($lang))
{
	$lang = array();
}
$lang = array_merge($lang, array(
	'FRAM_REQUESTS'						=> 'Manage Requests',
	'FRAM_REQUESTS_EXPLAIN'				=> 'Manage friend requests.',
	'FRAM_REQUESTED'					=> 'Request sent successfully. You will now be redirected to the last page.',
	'FRAM_BLOCKED'						=> 'Manage Blocked Members',
	'FRAM_BLOCKED_EXPLAIN'				=> 'Manage block list.',
	'FRAM_APPROVE'						=> 'Approve',
	'FRAM_DENY'							=> 'Deny',
	'FRAM_BLOCK'						=> 'Block',
	'FRAM_UNBLOCK'						=> 'Unblock',
	'FRAM_REQUEST_APPROVED'				=> 'Approved. You will now be redirected to the last page.',
	'FRAM_REQUEST_DENIED'				=> 'Denied. You will now be redirected to the last page.',
	'FRAM_REQUEST_BLOCKED'				=> 'Blocked. You will now be redirected to the last page.',
	'FRAM_USER_UNBLOCKED'				=> 'Unblocked. You will now be redirected to the last page.',
	'FRAM_REQUEST_MESSAGE'				=> 'Message',
	'FRAM_REQUEST_MESSAGE_EXPLAIN'		=> 'Optional message to send to your friend',
	'FRAM_NOT_ADDED_BLOCKED'			=> 'A user you tried to befriend is currently blocked',
	'FRAM_NOT_ADDED_REQUESTED'			=> 'You already requested friendship with a user in your list',
	'FRAM_APPROVED_SUBJECT'				=> 'Friendship Approved!',
	'FRAM_APPROVED_MESSAGE'				=> '<strong>%1$s</strong> has approved your friendship request and you are now friends. <strong>%1$s</strong> now appears on your friend list.',
    'FRAM_DENIED_SUBJECT'               => 'Friendship Denied!',
    'FRAM_DENIED_MESSAGE'               => '<strong>%1$s</strong> has denied your friendship request and you are not friends. <strong>%1$s</strong> will not appear on your friend list.',
    'FRAM_BLOCK_SUBJECT'                => 'Friendship Blocked!',
    'FRAM_BLOCK_MESSAGE'                => '<strong>%1$s</strong> has blocked you. <strong>%1$s</strong> will no longer see your post or receive your pms.',
	'FRAM_VIEW_REQUESTS_FROM'			=> 'From',
	'FRAM_VIEW_REQUESTS_EXPLAIN'		=> 'Information',
	'FRAM_VIEW_REQUESTS_OPTIONS'		=> 'Options',
	'FRAM_FRIEND_NOREQUESTS'			=> 'You have no friend requests at this time.',
	'FRAM_FRIEND_REQUEST_EXPLAIN'		=> 'Would like to be your friend.',	
	'FRAM_FRIEND_NOBLOCKEDS'			=> 'You have no members blocked at this time.',
	'FRAM_FRIEND_BLOCKEDS_EXPLAIN'		=> 'Will be allowed to make friend requests with you by clicking the unblock button below.',
	'FRAM_SETTINGS'						=> 'Manage Notifications',
	'FRAM_SETTINGS_EXPLAIN'				=> 'Enable or Disable the PM Notifications',
	'FRAM_SEND_APPROVE'					=> 'Send Approve PM Notifications',
	'FRAM_SEND_APPROVE_EXPLAIN'			=> 'Enable / Disable PM Approve Notifications',
	'FRAM_SEND_DENY'					=> 'Send Deny PM Notifications',
	'FRAM_SEND_DENY_EXPLAIN'			=> 'Enable / Disable PM Deny Notifications',
	'FRAM_SEND_BLOCK'					=> 'Send Block PM Notifications',
	'FRAM_SEND_BLOCK_EXPLAIN'			=> 'Enable / Disable PM Block Notifications',
	'FRAM_DISABLED_EXPLAIN'				=> 'The Administrator Has Disabled FRAM',
	'FRAM_ACP_FORCE'					=> '<strong>The Administrator is Forcing This Notification.</strong>',
));
?>