<?php
/**
 *
 * @mod Friend Request Approval Mod
 * @author Blue Blood (Blue Blood) blueblood@projectblueblood.com
 * @version 0.8.0
 * @copyright (c) 2010 Blue Blood
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 */
if (!defined('IN_PHPBB'))
{
	exit;
}
if (empty($lang) || !is_array($lang))
{
	$lang = array();
}
$lang = array_merge($lang, array(
	'FRAM_REQUESTS'						=> 'Gestionar Solicitudes',
	'FRAM_REQUESTS_EXPLAIN'				=> 'Gestionar las solicitudes de amistad.',
	'FRAM_REQUESTED'					=> 'Solicitud enviada con éxito. Ahora va a ser redirigido a la última página.',
	'FRAM_BLOCKED'						=> 'Administrar miembros bloqueados',
	'FRAM_BLOCKED_EXPLAIN'				=> 'Administrar la lista de bloqueo.',
	'FRAM_APPROVE'						=> 'Aprovar',
	'FRAM_DENY'							=> 'Rechazar',
	'FRAM_BLOCK'						=> 'Bloque',
	'FRAM_UNBLOCK'						=> 'Desbloquear',
	'FRAM_REQUEST_APPROVED'				=> 'Aprobado. Ahora va a ser redirigido a la última página.',
	'FRAM_REQUEST_DENIED'				=> 'Rechazar. Ahora va a ser redirigido a la última página.',
	'FRAM_REQUEST_BLOCKED'				=> 'Bloqueado. Ahora va a ser redirigido a la última página.',
	'FRAM_USER_UNBLOCKED'				=> 'Desbloqueado. Ahora va a ser redirigido a la última página.',
	'FRAM_REQUEST_MESSAGE'				=> 'Mensaje',
	'FRAM_REQUEST_MESSAGE_EXPLAIN'		=> 'Mensaje opcional para enviar a tus amigos',
	'FRAM_NOT_ADDED_BLOCKED'			=> 'Un usuario ha intentado hacer amistad está actualmente bloqueada',
	'FRAM_NOT_ADDED_REQUESTED'			=> 'Usted ya ha solicitado la amistad con un usuario en su lista',
	'FRAM_APPROVED_SUBJECT'				=> 'Amistad Aprobada!',
	'FRAM_APPROVED_MESSAGE'				=> '<strong>%1$s</strong>ha aprobado su solicitud de amistad y que son amigos. <strong>%1$s</strong> ahora aparece en su lista de amigos.',
    'FRAM_DENIED_SUBJECT'               => 'Amistad denegada!',
    'FRAM_DENIED_MESSAGE'               => '<strong>%1$s</strong> ha denegado su solicitud de amistad y que no son amigos. <strong>%1$s</strong> no aparecerá en tu lista de amigos.',
    'FRAM_BLOCK_SUBJECT'                => 'Amistad Bloqueada!',
    'FRAM_BLOCK_MESSAGE'                => '<strong>%1$s</strong> te ha bloqueado. <strong>%1$s</strong> ya no ver a su publicación, o recibir su MPS.',
	'FRAM_VIEW_REQUESTS_FROM'			=> 'Desde',
	'FRAM_VIEW_REQUESTS_EXPLAIN'		=> 'Información',
	'FRAM_VIEW_REQUESTS_OPTIONS'		=> 'Opciones',
	'FRAM_FRIEND_NOREQUESTS'			=> 'Usted no tiene solicitudes de amistad en este momento.',
	'FRAM_FRIEND_REQUEST_EXPLAIN'		=> '¿Te gustaría ser su amigo?.',	
	'FRAM_FRIEND_NOBLOCKEDS'			=> 'Usted no tiene bloqueados los miembros en este momento.',
	'FRAM_FRIEND_BLOCKEDS_EXPLAIN'		=> 'Podrán hacer solicitudes de amistad con usted haciendo clic en el botón de abajo desbloquear.',
	'FRAM_SETTINGS'						=> 'Administrar notificaciones',
	'FRAM_SETTINGS_EXPLAIN'				=> 'Activar o desactivar las notificaciones MP',
	'FRAM_SEND_APPROVE'					=> 'Enviar Aprobar Notificaciones MP',
	'FRAM_SEND_APPROVE_EXPLAIN'			=> 'Activar / Desactivar MP Aprobar Notificaciones',
	'FRAM_SEND_DENY'					=> 'Enviar Denegar Notificaciones PM',
	'FRAM_SEND_DENY_EXPLAIN'			=> 'Activar / Desactivar MP Denegar Notificaciones',
	'FRAM_SEND_BLOCK'					=> 'Enviar Bloque Notificaciones MP',
	'FRAM_SEND_BLOCK_EXPLAIN'			=> 'Activar / Desactivar notificaciones MP Bloque',
	'FRAM_DISABLED_EXPLAIN'				=> 'El administrador ha FRAM personas de movilidad reducida',
	'FRAM_ACP_FORCE'					=> '<strong>El Administrador está obligando a esta notificación.</strong>',
));
?>